/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package service;

import java.util.Collection;
import javax.ws.rs.Path;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Produces;
import javax.ws.rs.Consumes;
import javax.ws.rs.PathParam;
import javax.ws.rs.QueryParam;
import javax.ws.rs.DefaultValue;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.UriInfo;
import javax.persistence.EntityManager;
import converter.PersonnesConverter;
import converter.PersonneConverter;
import com.sun.jersey.api.core.ResourceContext;
import model.Personne;

/**
 *
 * @author michel
 */

@Path("/personnes/")
public class PersonnesResource {
    @Context
    protected ResourceContext resourceContext;
    @Context
    protected UriInfo uriInfo;
  
    /** Creates a new instance of PersonnesResource */
    public PersonnesResource() {
    }

    /**
     * Get method for retrieving a collection of Personne instance in XML format.
     *
     * @return an instance of PersonnesConverter
     */
    @GET
    @Produces({"application/json"})
    public PersonnesConverter get(@QueryParam("start")
                                  @DefaultValue("0")
    int start, @QueryParam("max")
               @DefaultValue("10")
    int max, @QueryParam("expandLevel")
             @DefaultValue("1")
    int expandLevel, @QueryParam("query")
                     @DefaultValue("SELECT e FROM Personne e")
    String query) {
        PersistenceService persistenceSvc = PersistenceService.getInstance();
        try {
            persistenceSvc.beginTx();
            return new PersonnesConverter(getEntities(start, max, query), uriInfo.getAbsolutePath(), expandLevel);
        } finally {
            persistenceSvc.commitTx();
            persistenceSvc.close();
        }
    }

    /**
     * Post method for creating an instance of Personne using XML as the input format.
     *
     * @param data an PersonneConverter entity that is deserialized from an XML stream
     * @return an instance of PersonneConverter
     */
    @POST
    @Consumes({"application/json"})
    public Response post(PersonneConverter data) {
        PersistenceService persistenceSvc = PersistenceService.getInstance();
        try {
            persistenceSvc.beginTx();
            EntityManager em = persistenceSvc.getEntityManager();
            Personne entity = data.resolveEntity(em);
            createEntity(data.resolveEntity(em));
            persistenceSvc.commitTx();
            return Response.created(uriInfo.getAbsolutePath().resolve(entity.getId() + "/")).build();
        } finally {
            persistenceSvc.close();
        }
    }

    /**
     * Returns a dynamic instance of PersonneResource used for entity navigation.
     *
     * @return an instance of PersonneResource
     */
    @Path("{id}/")
    public PersonneResource getPersonneResource(@PathParam("id")
    Integer id) {
        PersonneResource personneResource = resourceContext.getResource(PersonneResource.class);
        personneResource.setId(id);
        return personneResource;
    }

    /**
     * Returns all the entities associated with this resource.
     *
     * @return a collection of Personne instances
     */
    protected Collection<Personne> getEntities(int start, int max, String query) {
        EntityManager em = PersistenceService.getInstance().getEntityManager();
        return em.createQuery(query).setFirstResult(start).setMaxResults(max).getResultList();
    }

    /**
     * Persist the given entity.
     *
     * @param entity the entity to persist
     */
    protected void createEntity(Personne entity) {
        EntityManager em = PersistenceService.getInstance().getEntityManager();
        em.persist(entity);
    }
}
